/*
 * Copyright 1994, 1995 Vectaport Inc., Cartoactive Systems
 *
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the names of the copyright holders not be used in
 * advertising or publicity pertaining to distribution of the software
 * without specific, written prior permission.  The copyright holders make
 * no representations about the suitability of this software for any purpose.
 * It is provided "as is" without express or implied warranty.
 *
 * THE COPYRIGHT HOLDERS DISCLAIM ALL WARRANTIES WITH REGARD TO THIS
 * SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS.
 * IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY SPECIAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING
 * FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
 * NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
 * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 * 
 */

#include <MapUnidraw/mapdialog.h>
#include <MapUnidraw/mapclasses.h>
#include <MapUnidraw/mapeditor.h>
#include <MapUnidraw/mappoint.h>

#include <IV-look/kit.h>
#include <InterViews/session.h>
#include <InterViews/window.h>
#include <stdio.h>

ClassId PointCmd::GetClassId () { return POINT_CMD; }

boolean PointCmd::IsA (ClassId id) {
    return POINT_CMD == id || Command::IsA(id);
}

PointCmd::PointCmd (ControlInfo* c) : Command(c) { Init(); }
PointCmd::PointCmd (Editor* ed) : Command(ed) { Init(); }

void PointCmd::Init() {
  _dialog = new PointDialog(WidgetKit::instance(),
			    Session::instance()->style());
  Resource::ref(_dialog);
}

Command* PointCmd::Copy () {
    Command* copy = new PointCmd(CopyControlInfo());
    InitCopy(copy);
    return copy;
}

void PointCmd::Execute () {
    MapEditor* editor = (MapEditor*)GetEditor();
    while (_dialog->post_for(editor->GetWindow())) {
        float lat, lon;
        if (_dialog->values(lat, lon)) {
	    editor->AddPoint(lat, lon);
	    break;
	}
    }
}

boolean PointCmd::Reversible () { return true; }
